/*
 * @OSF_FREE_FREE_COPYRIGHT@
 * 
 */
/*
 * HISTORY
 * $Log: setup.c,v $
 * Revision 1.1.2.2  1996/09/18  14:25:10  barbou
 * 	Moved screen_info structure to machine-dependent kernel/setup.c.
 * 	[96/09/16            barbou]
 *
 * Revision 1.1.2.1  1996/09/09  17:17:08  barbou
 * 	Created.
 * 	[1996/08/27  17:24:52  barbou]
 * 
 * $EndLog$
 */

/*
 * Machine-independent routines from arch/.../kernel/setup.c.
 */

#include <mach/mach_interface.h>
#include <osfmach3/mach3_debug.h>
#include <osfmach3/mach_init.h>

#include <linux/tty.h>
#include <linux/mm.h>

extern int root_mountflags;
char *server_command_line = "ro";	/* XXX should get that from lilo */
char **server_command_line_p = &server_command_line;
#define COMMAND_LINE_SIZE 256
char saved_command_line[COMMAND_LINE_SIZE];

extern void set_rootdev(void);

unsigned long		initial_start_mem;

void setup_arch(char **cmdline_p,
	unsigned long * memory_start_p, unsigned long * memory_end_p)
{
	kern_return_t	kr;
	unsigned long	initial_mem_size;

	set_rootdev();
	/*
	 * Reserve a bunch of memory for subsystems initialization.
	 * The extra memory will be freed in osfmach3_mem_init after
	 * every subsystem had a chance to reserve some memory.
	 */
	initial_mem_size = 64*1024*104;	/* 64 */
	kr = vm_allocate(mach_task_self(),
			 (vm_offset_t *) &initial_start_mem,
			 initial_mem_size,
			 TRUE);
	if (kr != KERN_SUCCESS) {
		MACH3_DEBUG(0, kr, ("setup_arch: vm_allocate(&start_mem)"));
		panic("setup_arch: can't set memory_start");
	}

	/* Save unparsed command line copy for /proc/cmdline */
	memcpy(saved_command_line, server_command_line, COMMAND_LINE_SIZE);
	saved_command_line[COMMAND_LINE_SIZE-1] = '\0';

	*memory_start_p = initial_start_mem;
	*memory_end_p = initial_start_mem + initial_mem_size;
	*cmdline_p = *server_command_line_p;

}
